/* TkWin version 0.2 -- Tk for Windows
 * Copyright (C) 1994 K. K. Kubota
 * Mathematical Sciences Computing Facility, University of Kentucky,
 * Lexington, KY 40506, USA (e-mail: ken@ms.uky.edu)
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose is granted without fee, provided that the above copyright notice
 * and the following paragraph appear in all copies of this software
 * and supporting documentation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  In no event shall the author be
 * liable to any party for direct, indirect, special, incidental, or
 * consequential damages arising out of the use of this software and its
 * documentation.
 */

/* Color Lookup Tables */
static struct syscolor {
    long index;
    char *name;
} sysColorList[] = {
    {COLOR_SCROLLBAR, "scrollbar"},
    {COLOR_BACKGROUND , "background"},
    {COLOR_ACTIVECAPTION, "activetitle"},
    {COLOR_INACTIVECAPTION, "inactivetitle"},
    {COLOR_MENU, "menu"},
    {COLOR_WINDOW, "window"},
    {COLOR_WINDOWFRAME, "windowframe"},
    {COLOR_MENUTEXT, "menutext"},
    {COLOR_WINDOWTEXT, "windowtext"},
    {COLOR_CAPTIONTEXT, "titletext"},
    {COLOR_ACTIVEBORDER, "activebordertext"},
    {COLOR_INACTIVEBORDER, "inactivebordertext"},
    {COLOR_APPWORKSPACE, "appworkspace"},
    {COLOR_HIGHLIGHT, "highlight"},
    {COLOR_HIGHLIGHTTEXT, "highlighttext"},
    {COLOR_BTNFACE, "buttonface"},
    {COLOR_BTNSHADOW, "buttonshadow"},
    {COLOR_GRAYTEXT, "graytext"},
    {COLOR_BTNTEXT, "buttontext"},
    {COLOR_INACTIVECAPTIONTEXT, "inactivetitletext"},
    {COLOR_BTNHIGHLIGHT, "buttonhighlight"},
    {-1, NULL}
};

static struct color {
    long value;
    char *name;
} colorList[] = {
    {0xfffafaL, "snow"},
    {0xf8f8ffL, "ghost white"},
    {0xf8f8ffL, "ghostwhite"},
    {0xf5f5f5L, "white smoke"},
    {0xf5f5f5L, "whitesmoke"},
    {0xdcdcdcL, "gainsboro"},
    {0xfffaf0L, "floral white"},
    {0xfffaf0L, "floralwhite"},
    {0xfdf5e6L, "old lace"},
    {0xfdf5e6L, "oldlace"},
    {0xfaf0e6L, "linen"},
    {0xfaebd7L, "antique white"},
    {0xfaebd7L, "antiquewhite"},
    {0xffefd5L, "papaya whip"},
    {0xffefd5L, "papayawhip"},
    {0xffebcdL, "blanched almond"},
    {0xffebcdL, "blanchedalmond"},
    {0xffe4c4L, "bisque"},
    {0xffdab9L, "peach puff"},
    {0xffdab9L, "peachpuff"},
    {0xffdeadL, "navajo white"},
    {0xffdeadL, "navajowhite"},
    {0xffe4b5L, "moccasin"},
    {0xfff8dcL, "cornsilk"},
    {0xfffff0L, "ivory"},
    {0xfffacdL, "lemon chiffon"},
    {0xfffacdL, "lemonchiffon"},
    {0xfff5eeL, "seashell"},
    {0xf0fff0L, "honeydew"},
    {0xf5fffaL, "mint cream"},
    {0xf5fffaL, "mintcream"},
    {0xf0ffffL, "azure"},
    {0xf0f8ffL, "alice blue"},
    {0xf0f8ffL, "aliceblue"},
    {0xe6e6faL, "lavender"},
    {0xfff0f5L, "lavender blush"},
    {0xfff0f5L, "lavenderblush"},
    {0xffe4e1L, "misty rose"},
    {0xffe4e1L, "mistyrose"},
    {0xffffffL, "white"},
    {0x000000L, "black"},
    {0x2f4f4fL, "dark slate gray"},
    {0x2f4f4fL, "darkslategray"},
    {0x2f4f4fL, "dark slate grey"},
    {0x2f4f4fL, "darkslategrey"},
    {0x696969L, "dim gray"},
    {0x696969L, "dimgray"},
    {0x696969L, "dim grey"},
    {0x696969L, "dimgrey"},
    {0x708090L, "slate gray"},
    {0x708090L, "slategray"},
    {0x708090L, "slate grey"},
    {0x708090L, "slategrey"},
    {0x778899L, "light slate gray"},
    {0x778899L, "lightslategray"},
    {0x778899L, "light slate grey"},
    {0x778899L, "lightslategrey"},
    {0xbebebeL, "gray"},
    {0xbebebeL, "grey"},
    {0xd3d3d3L, "light grey"},
    {0xd3d3d3L, "lightgrey"},
    {0xd3d3d3L, "light gray"},
    {0xd3d3d3L, "lightgray"},
    {0x191970L, "midnight blue"},
    {0x191970L, "midnightblue"},
    {0x000080L, "navy"},
    {0x000080L, "navy blue"},
    {0x000080L, "navyblue"},
    {0x000080L, "darkblue"}, /* added for Windows */
    {0x6495edL, "cornflower blue"},
    {0x6495edL, "cornflowerblue"},
    {0x483d8bL, "dark slate blue"},
    {0x483d8bL, "darkslateblue"},
    {0x6a5acdL, "slate blue"},
    {0x6a5acdL, "slateblue"},
    {0x7b68eeL, "medium slate blue"},
    {0x7b68eeL, "mediumslateblue"},
    {0x8470ffL, "light slate blue"},
    {0x8470ffL, "lightslateblue"},
    {0x0000cdL, "medium blue"},
    {0x0000cdL, "mediumblue"},
    {0x4169e1L, "royal blue"},
    {0x4169e1L, "royalblue"},
    {0x0000ffL, "blue"},
    {0x1e90ffL, "dodger blue"},
    {0x1e90ffL, "dodgerblue"},
    {0x00bfffL, "deep sky blue"},
    {0x00bfffL, "deepskyblue"},
    {0x87ceebL, "sky blue"},
    {0x87ceebL, "skyblue"},
    {0x87cefaL, "light sky blue"},
    {0x87cefaL, "lightskyblue"},
    {0x4682b4L, "steel blue"},
    {0x4682b4L, "steelblue"},
    {0xb0c4deL, "light steel blue"},
    {0xb0c4deL, "lightsteelblue"},
    {0xadd8e6L, "light blue"},
    {0xadd8e6L, "lightblue"},
    {0xb0e0e6L, "powder blue"},
    {0xb0e0e6L, "powderblue"},
    {0xafeeeeL, "pale turquoise"},
    {0xafeeeeL, "paleturquoise"},
    {0x00ced1L, "dark turquoise"},
    {0x00ced1L, "darkturquoise"},
    {0x48d1ccL, "medium turquoise"},
    {0x48d1ccL, "mediumturquoise"},
    {0x40e0d0L, "turquoise"},
    {0x00ffffL, "cyan"},
    {0x008080L, "darkcyan"}, /* Added for Windows */
    {0xe0ffffL, "light cyan"},
    {0xe0ffffL, "lightcyan"},
    {0x5f9ea0L, "cadet blue"},
    {0x5f9ea0L, "cadetblue"},
    {0x66cdaaL, "medium aquamarine"},
    {0x66cdaaL, "mediumaquamarine"},
    {0x7fffd4L, "aquamarine"},
    {0x006400L, "dark green"},
/* Removed this because of name conflict
 * with Windows color
 *    {0x006400L, "darkgreen"},
 */
    {0x00ff00L, "darkgreen"}, /* Added for Windows */
    {0x556b2fL, "dark olive green"},
    {0x556b2fL, "darkolivegreen"},
    {0x8fbc8fL, "dark sea green"},
    {0x8fbc8fL, "darkseagreen"},
    {0x2e8b57L, "sea green"},
    {0x2e8b57L, "seagreen"},
    {0x3cb371L, "medium sea green"},
    {0x3cb371L, "mediumseagreen"},
    {0x20b2aaL, "light sea green"},
    {0x20b2aaL, "lightseagreen"},
    {0x98fb98L, "pale green"},
    {0x98fb98L, "palegreen"},
    {0x00ff7fL, "spring green"},
    {0x00ff7fL, "springgreen"},
    {0x7cfc00L, "lawn green"},
    {0x7cfc00L, "lawngreen"},
    {0x00ff00L, "green"},
    {0x7fff00L, "chartreuse"},
    {0x00fa9aL, "medium spring green"},
    {0x00fa9aL, "mediumspringgreen"},
    {0xadff2fL, "green yellow"},
    {0xadff2fL, "greenyellow"},
    {0x32cd32L, "lime green"},
    {0x32cd32L, "limegreen"},
    {0x9acd32L, "yellow green"},
    {0x9acd32L, "yellowgreen"},
    {0x228b22L, "forest green"},
    {0x228b22L, "forestgreen"},
    {0x6b8e23L, "olive drab"},
    {0x6b8e23L, "olivedrab"},
    {0xbdb76bL, "dark khaki"},
    {0xbdb76bL, "darkkhaki"},
    {0xf0e68cL, "khaki"},
    {0xeee8aaL, "pale goldenrod"},
    {0xeee8aaL, "palegoldenrod"},
    {0xfafad2L, "light goldenrod yellow"},
    {0xfafad2L, "lightgoldenrodyellow"},
    {0xffffe0L, "light yellow"},
    {0xffffe0L, "lightyellow"},
    {0xffff00L, "yellow"},
    {0x808000L, "darkyellow"},	/* Added for Windows */
    {0xffd700L, "gold"},
    {0xeedd82L, "light goldenrod"},
    {0xeedd82L, "lightgoldenrod"},
    {0xdaa520L, "goldenrod"},
    {0xb8860bL, "dark goldenrod"},
    {0xb8860bL, "darkgoldenrod"},
    {0xbc8f8fL, "rosy brown"},
    {0xbc8f8fL, "rosybrown"},
    {0xcd5c5cL, "indian red"},
    {0xcd5c5cL, "indianred"},
    {0x8b4513L, "saddle brown"},
    {0x8b4513L, "saddlebrown"},
    {0xa0522dL, "sienna"},
    {0xcd853fL, "peru"},
    {0xdeb887L, "burlywood"},
    {0xf5f5dcL, "beige"},
    {0xf5deb3L, "wheat"},
    {0xf4a460L, "sandy brown"},
    {0xf4a460L, "sandybrown"},
    {0xd2b48cL, "tan"},
    {0xd2691eL, "chocolate"},
    {0xb22222L, "firebrick"},
    {0xa52a2aL, "brown"},
    {0xe9967aL, "dark salmon"},
    {0xe9967aL, "darksalmon"},
    {0xfa8072L, "salmon"},
    {0xffa07aL, "light salmon"},
    {0xffa07aL, "lightsalmon"},
    {0xffa500L, "orange"},
    {0xff8c00L, "dark orange"},
    {0xff8c00L, "darkorange"},
    {0xff7f50L, "coral"},
    {0xf08080L, "light coral"},
    {0xf08080L, "lightcoral"},
    {0xff6347L, "tomato"},
    {0xff4500L, "orange red"},
    {0xff4500L, "orangered"},
    {0xff0000L, "red"},
    {0x800000L, "darkred"}, /* Added for Windows */
    {0xff69b4L, "hot pink"},
    {0xff69b4L, "hotpink"},
    {0xff1493L, "deep pink"},
    {0xff1493L, "deeppink"},
    {0xffc0cbL, "pink"},
    {0xffb6c1L, "light pink"},
    {0xffb6c1L, "lightpink"},
    {0xdb7093L, "pale violet red"},
    {0xdb7093L, "palevioletred"},
    {0xb03060L, "maroon"},
    {0xc71585L, "medium violet red"},
    {0xc71585L, "mediumvioletred"},
    {0xd02090L, "violet red"},
    {0xd02090L, "violetred"},
    {0xff00ffL, "magenta"},
    {0x800080L, "darkmagenta"}, /* Added for Windows */
    {0xee82eeL, "violet"},
    {0xdda0ddL, "plum"},
    {0xda70d6L, "orchid"},
    {0xba55d3L, "medium orchid"},
    {0xba55d3L, "mediumorchid"},
    {0x9932ccL, "dark orchid"},
    {0x9932ccL, "darkorchid"},
    {0x9400d3L, "dark violet"},
    {0x9400d3L, "darkviolet"},
    {0x8a2be2L, "blue violet"},
    {0x8a2be2L, "blueviolet"},
    {0xa020f0L, "purple"},
    {0x9370dbL, "medium purple"},
    {0x9370dbL, "mediumpurple"},
    {0xd8bfd8L, "thistle"},
    {0xfffafaL, "snow1"},
    {0xeee9e9L, "snow2"},
    {0xcdc9c9L, "snow3"},
    {0x8b8989L, "snow4"},
    {0xfff5eeL, "seashell1"},
    {0xeee5deL, "seashell2"},
    {0xcdc5bfL, "seashell3"},
    {0x8b8682L, "seashell4"},
    {0xffefdbL, "antiquewhite1"},
    {0xeedfccL, "antiquewhite2"},
    {0xcdc0b0L, "antiquewhite3"},
    {0x8b8378L, "antiquewhite4"},
    {0xffe4c4L, "bisque1"},
    {0xeed5b7L, "bisque2"},
    {0xcdb79eL, "bisque3"},
    {0x8b7d6bL, "bisque4"},
    {0xffdab9L, "peachpuff1"},
    {0xeecbadL, "peachpuff2"},
    {0xcdaf95L, "peachpuff3"},
    {0x8b7765L, "peachpuff4"},
    {0xffdeadL, "navajowhite1"},
    {0xeecfa1L, "navajowhite2"},
    {0xcdb38bL, "navajowhite3"},
    {0x8b795eL, "navajowhite4"},
    {0xfffacdL, "lemonchiffon1"},
    {0xeee9bfL, "lemonchiffon2"},
    {0xcdc9a5L, "lemonchiffon3"},
    {0x8b8970L, "lemonchiffon4"},
    {0xfff8dcL, "cornsilk1"},
    {0xeee8cdL, "cornsilk2"},
    {0xcdc8b1L, "cornsilk3"},
    {0x8b8878L, "cornsilk4"},
    {0xfffff0L, "ivory1"},
    {0xeeeee0L, "ivory2"},
    {0xcdcdc1L, "ivory3"},
    {0x8b8b83L, "ivory4"},
    {0xf0fff0L, "honeydew1"},
    {0xe0eee0L, "honeydew2"},
    {0xc1cdc1L, "honeydew3"},
    {0x838b83L, "honeydew4"},
    {0xfff0f5L, "lavenderblush1"},
    {0xeee0e5L, "lavenderblush2"},
    {0xcdc1c5L, "lavenderblush3"},
    {0x8b8386L, "lavenderblush4"},
    {0xffe4e1L, "mistyrose1"},
    {0xeed5d2L, "mistyrose2"},
    {0xcdb7b5L, "mistyrose3"},
    {0x8b7d7bL, "mistyrose4"},
    {0xf0ffffL, "azure1"},
    {0xe0eeeeL, "azure2"},
    {0xc1cdcdL, "azure3"},
    {0x838b8bL, "azure4"},
    {0x836fffL, "slateblue1"},
    {0x7a67eeL, "slateblue2"},
    {0x6959cdL, "slateblue3"},
    {0x473c8bL, "slateblue4"},
    {0x4876ffL, "royalblue1"},
    {0x436eeeL, "royalblue2"},
    {0x3a5fcdL, "royalblue3"},
    {0x27408bL, "royalblue4"},
    {0x0000ffL, "blue1"},
    {0x0000eeL, "blue2"},
    {0x0000cdL, "blue3"},
    {0x00008bL, "blue4"},
    {0x1e90ffL, "dodgerblue1"},
    {0x1c86eeL, "dodgerblue2"},
    {0x1874cdL, "dodgerblue3"},
    {0x104e8bL, "dodgerblue4"},
    {0x63b8ffL, "steelblue1"},
    {0x5caceeL, "steelblue2"},
    {0x4f94cdL, "steelblue3"},
    {0x36648bL, "steelblue4"},
    {0x00bfffL, "deepskyblue1"},
    {0x00b2eeL, "deepskyblue2"},
    {0x009acdL, "deepskyblue3"},
    {0x00688bL, "deepskyblue4"},
    {0x87ceffL, "skyblue1"},
    {0x7ec0eeL, "skyblue2"},
    {0x6ca6cdL, "skyblue3"},
    {0x4a708bL, "skyblue4"},
    {0xb0e2ffL, "lightskyblue1"},
    {0xa4d3eeL, "lightskyblue2"},
    {0x8db6cdL, "lightskyblue3"},
    {0x607b8bL, "lightskyblue4"},
    {0xc6e2ffL, "slategray1"},
    {0xb9d3eeL, "slategray2"},
    {0x9fb6cdL, "slategray3"},
    {0x6c7b8bL, "slategray4"},
    {0xcae1ffL, "lightsteelblue1"},
    {0xbcd2eeL, "lightsteelblue2"},
    {0xa2b5cdL, "lightsteelblue3"},
    {0x6e7b8bL, "lightsteelblue4"},
    {0xbfefffL, "lightblue1"},
    {0xb2dfeeL, "lightblue2"},
    {0x9ac0cdL, "lightblue3"},
    {0x68838bL, "lightblue4"},
    {0xe0ffffL, "lightcyan1"},
    {0xd1eeeeL, "lightcyan2"},
    {0xb4cdcdL, "lightcyan3"},
    {0x7a8b8bL, "lightcyan4"},
    {0xbbffffL, "paleturquoise1"},
    {0xaeeeeeL, "paleturquoise2"},
    {0x96cdcdL, "paleturquoise3"},
    {0x668b8bL, "paleturquoise4"},
    {0x98f5ffL, "cadetblue1"},
    {0x8ee5eeL, "cadetblue2"},
    {0x7ac5cdL, "cadetblue3"},
    {0x53868bL, "cadetblue4"},
    {0x00f5ffL, "turquoise1"},
    {0x00e5eeL, "turquoise2"},
    {0x00c5cdL, "turquoise3"},
    {0x00868bL, "turquoise4"},
    {0x00ffffL, "cyan1"},
    {0x00eeeeL, "cyan2"},
    {0x00cdcdL, "cyan3"},
    {0x008b8bL, "cyan4"},
    {0x97ffffL, "darkslategray1"},
    {0x8deeeeL, "darkslategray2"},
    {0x79cdcdL, "darkslategray3"},
    {0x528b8bL, "darkslategray4"},
    {0x7fffd4L, "aquamarine1"},
    {0x76eec6L, "aquamarine2"},
    {0x66cdaaL, "aquamarine3"},
    {0x458b74L, "aquamarine4"},
    {0xc1ffc1L, "darkseagreen1"},
    {0xb4eeb4L, "darkseagreen2"},
    {0x9bcd9bL, "darkseagreen3"},
    {0x698b69L, "darkseagreen4"},
    {0x54ff9fL, "seagreen1"},
    {0x4eee94L, "seagreen2"},
    {0x43cd80L, "seagreen3"},
    {0x2e8b57L, "seagreen4"},
    {0x9aff9aL, "palegreen1"},
    {0x90ee90L, "palegreen2"},
    {0x7ccd7cL, "palegreen3"},
    {0x548b54L, "palegreen4"},
    {0x00ff7fL, "springgreen1"},
    {0x00ee76L, "springgreen2"},
    {0x00cd66L, "springgreen3"},
    {0x008b45L, "springgreen4"},
    {0x00ff00L, "green1"},
    {0x00ee00L, "green2"},
    {0x00cd00L, "green3"},
    {0x008b00L, "green4"},
    {0x7fff00L, "chartreuse1"},
    {0x76ee00L, "chartreuse2"},
    {0x66cd00L, "chartreuse3"},
    {0x458b00L, "chartreuse4"},
    {0xc0ff3eL, "olivedrab1"},
    {0xb3ee3aL, "olivedrab2"},
    {0x9acd32L, "olivedrab3"},
    {0x698b22L, "olivedrab4"},
    {0xcaff70L, "darkolivegreen1"},
    {0xbcee68L, "darkolivegreen2"},
    {0xa2cd5aL, "darkolivegreen3"},
    {0x6e8b3dL, "darkolivegreen4"},
    {0xfff68fL, "khaki1"},
    {0xeee685L, "khaki2"},
    {0xcdc673L, "khaki3"},
    {0x8b864eL, "khaki4"},
    {0xffec8bL, "lightgoldenrod1"},
    {0xeedc82L, "lightgoldenrod2"},
    {0xcdbe70L, "lightgoldenrod3"},
    {0x8b814cL, "lightgoldenrod4"},
    {0xffffe0L, "lightyellow1"},
    {0xeeeed1L, "lightyellow2"},
    {0xcdcdb4L, "lightyellow3"},
    {0x8b8b7aL, "lightyellow4"},
    {0xffff00L, "yellow1"},
    {0xeeee00L, "yellow2"},
    {0xcdcd00L, "yellow3"},
    {0x8b8b00L, "yellow4"},
    {0xffd700L, "gold1"},
    {0xeec900L, "gold2"},
    {0xcdad00L, "gold3"},
    {0x8b7500L, "gold4"},
    {0xffc125L, "goldenrod1"},
    {0xeeb422L, "goldenrod2"},
    {0xcd9b1dL, "goldenrod3"},
    {0x8b6914L, "goldenrod4"},
    {0xffb90fL, "darkgoldenrod1"},
    {0xeead0eL, "darkgoldenrod2"},
    {0xcd950cL, "darkgoldenrod3"},
    {0x8b6508L, "darkgoldenrod4"},
    {0xffc1c1L, "rosybrown1"},
    {0xeeb4b4L, "rosybrown2"},
    {0xcd9b9bL, "rosybrown3"},
    {0x8b6969L, "rosybrown4"},
    {0xff6a6aL, "indianred1"},
    {0xee6363L, "indianred2"},
    {0xcd5555L, "indianred3"},
    {0x8b3a3aL, "indianred4"},
    {0xff8247L, "sienna1"},
    {0xee7942L, "sienna2"},
    {0xcd6839L, "sienna3"},
    {0x8b4726L, "sienna4"},
    {0xffd39bL, "burlywood1"},
    {0xeec591L, "burlywood2"},
    {0xcdaa7dL, "burlywood3"},
    {0x8b7355L, "burlywood4"},
    {0xffe7baL, "wheat1"},
    {0xeed8aeL, "wheat2"},
    {0xcdba96L, "wheat3"},
    {0x8b7e66L, "wheat4"},
    {0xffa54fL, "tan1"},
    {0xee9a49L, "tan2"},
    {0xcd853fL, "tan3"},
    {0x8b5a2bL, "tan4"},
    {0xff7f24L, "chocolate1"},
    {0xee7621L, "chocolate2"},
    {0xcd661dL, "chocolate3"},
    {0x8b4513L, "chocolate4"},
    {0xff3030L, "firebrick1"},
    {0xee2c2cL, "firebrick2"},
    {0xcd2626L, "firebrick3"},
    {0x8b1a1aL, "firebrick4"},
    {0xff4040L, "brown1"},
    {0xee3b3bL, "brown2"},
    {0xcd3333L, "brown3"},
    {0x8b2323L, "brown4"},
    {0xff8c69L, "salmon1"},
    {0xee8262L, "salmon2"},
    {0xcd7054L, "salmon3"},
    {0x8b4c39L, "salmon4"},
    {0xffa07aL, "lightsalmon1"},
    {0xee9572L, "lightsalmon2"},
    {0xcd8162L, "lightsalmon3"},
    {0x8b5742L, "lightsalmon4"},
    {0xffa500L, "orange1"},
    {0xee9a00L, "orange2"},
    {0xcd8500L, "orange3"},
    {0x8b5a00L, "orange4"},
    {0xff7f00L, "darkorange1"},
    {0xee7600L, "darkorange2"},
    {0xcd6600L, "darkorange3"},
    {0x8b4500L, "darkorange4"},
    {0xff7256L, "coral1"},
    {0xee6a50L, "coral2"},
    {0xcd5b45L, "coral3"},
    {0x8b3e2fL, "coral4"},
    {0xff6347L, "tomato1"},
    {0xee5c42L, "tomato2"},
    {0xcd4f39L, "tomato3"},
    {0x8b3626L, "tomato4"},
    {0xff4500L, "orangered1"},
    {0xee4000L, "orangered2"},
    {0xcd3700L, "orangered3"},
    {0x8b2500L, "orangered4"},
    {0xff0000L, "red1"},
    {0xee0000L, "red2"},
    {0xcd0000L, "red3"},
    {0x8b0000L, "red4"},
    {0xff1493L, "deeppink1"},
    {0xee1289L, "deeppink2"},
    {0xcd1076L, "deeppink3"},
    {0x8b0a50L, "deeppink4"},
    {0xff6eb4L, "hotpink1"},
    {0xee6aa7L, "hotpink2"},
    {0xcd6090L, "hotpink3"},
    {0x8b3a62L, "hotpink4"},
    {0xffb5c5L, "pink1"},
    {0xeea9b8L, "pink2"},
    {0xcd919eL, "pink3"},
    {0x8b636cL, "pink4"},
    {0xffaeb9L, "lightpink1"},
    {0xeea2adL, "lightpink2"},
    {0xcd8c95L, "lightpink3"},
    {0x8b5f65L, "lightpink4"},
    {0xff82abL, "palevioletred1"},
    {0xee799fL, "palevioletred2"},
    {0xcd6889L, "palevioletred3"},
    {0x8b475dL, "palevioletred4"},
    {0xff34b3L, "maroon1"},
    {0xee30a7L, "maroon2"},
    {0xcd2990L, "maroon3"},
    {0x8b1c62L, "maroon4"},
    {0xff3e96L, "violetred1"},
    {0xee3a8cL, "violetred2"},
    {0xcd3278L, "violetred3"},
    {0x8b2252L, "violetred4"},
    {0xff00ffL, "magenta1"},
    {0xee00eeL, "magenta2"},
    {0xcd00cdL, "magenta3"},
    {0x8b008bL, "magenta4"},
    {0xff83faL, "orchid1"},
    {0xee7ae9L, "orchid2"},
    {0xcd69c9L, "orchid3"},
    {0x8b4789L, "orchid4"},
    {0xffbbffL, "plum1"},
    {0xeeaeeeL, "plum2"},
    {0xcd96cdL, "plum3"},
    {0x8b668bL, "plum4"},
    {0xe066ffL, "mediumorchid1"},
    {0xd15feeL, "mediumorchid2"},
    {0xb452cdL, "mediumorchid3"},
    {0x7a378bL, "mediumorchid4"},
    {0xbf3effL, "darkorchid1"},
    {0xb23aeeL, "darkorchid2"},
    {0x9a32cdL, "darkorchid3"},
    {0x68228bL, "darkorchid4"},
    {0x9b30ffL, "purple1"},
    {0x912ceeL, "purple2"},
    {0x7d26cdL, "purple3"},
    {0x551a8bL, "purple4"},
    {0xab82ffL, "mediumpurple1"},
    {0x9f79eeL, "mediumpurple2"},
    {0x8968cdL, "mediumpurple3"},
    {0x5d478bL, "mediumpurple4"},
    {0xffe1ffL, "thistle1"},
    {0xeed2eeL, "thistle2"},
    {0xcdb5cdL, "thistle3"},
    {0x8b7b8bL, "thistle4"},
    {0x808080L, "darkgray"}, /* Added for Windows */
    {0xc0c0c0L, "mediumgray"}, /* Added for Windows */
    {0x000000L, "gray0"},
    {0x000000L, "grey0"},
    {0x030303L, "gray1"},
    {0x030303L, "grey1"},
    {0x050505L, "gray2"},
    {0x050505L, "grey2"},
    {0x080808L, "gray3"},
    {0x080808L, "grey3"},
    {0x0a0a0aL, "gray4"},
    {0x0a0a0aL, "grey4"},
    {0x0d0d0dL, "gray5"},
    {0x0d0d0dL, "grey5"},
    {0x0f0f0fL, "gray6"},
    {0x0f0f0fL, "grey6"},
    {0x121212L, "gray7"},
    {0x121212L, "grey7"},
    {0x141414L, "gray8"},
    {0x141414L, "grey8"},
    {0x171717L, "gray9"},
    {0x171717L, "grey9"},
    {0x1a1a1aL, "gray10"},
    {0x1a1a1aL, "grey10"},
    {0x1c1c1cL, "gray11"},
    {0x1c1c1cL, "grey11"},
    {0x1f1f1fL, "gray12"},
    {0x1f1f1fL, "grey12"},
    {0x212121L, "gray13"},
    {0x212121L, "grey13"},
    {0x242424L, "gray14"},
    {0x242424L, "grey14"},
    {0x262626L, "gray15"},
    {0x262626L, "grey15"},
    {0x292929L, "gray16"},
    {0x292929L, "grey16"},
    {0x2b2b2bL, "gray17"},
    {0x2b2b2bL, "grey17"},
    {0x2e2e2eL, "gray18"},
    {0x2e2e2eL, "grey18"},
    {0x303030L, "gray19"},
    {0x303030L, "grey19"},
    {0x333333L, "gray20"},
    {0x333333L, "grey20"},
    {0x363636L, "gray21"},
    {0x363636L, "grey21"},
    {0x383838L, "gray22"},
    {0x383838L, "grey22"},
    {0x3b3b3bL, "gray23"},
    {0x3b3b3bL, "grey23"},
    {0x3d3d3dL, "gray24"},
    {0x3d3d3dL, "grey24"},
    {0x404040L, "gray25"},
    {0x404040L, "grey25"},
    {0x424242L, "gray26"},
    {0x424242L, "grey26"},
    {0x454545L, "gray27"},
    {0x454545L, "grey27"},
    {0x474747L, "gray28"},
    {0x474747L, "grey28"},
    {0x4a4a4aL, "gray29"},
    {0x4a4a4aL, "grey29"},
    {0x4d4d4dL, "gray30"},
    {0x4d4d4dL, "grey30"},
    {0x4f4f4fL, "gray31"},
    {0x4f4f4fL, "grey31"},
    {0x525252L, "gray32"},
    {0x525252L, "grey32"},
    {0x545454L, "gray33"},
    {0x545454L, "grey33"},
    {0x575757L, "gray34"},
    {0x575757L, "grey34"},
    {0x595959L, "gray35"},
    {0x595959L, "grey35"},
    {0x5c5c5cL, "gray36"},
    {0x5c5c5cL, "grey36"},
    {0x5e5e5eL, "gray37"},
    {0x5e5e5eL, "grey37"},
    {0x616161L, "gray38"},
    {0x616161L, "grey38"},
    {0x636363L, "gray39"},
    {0x636363L, "grey39"},
    {0x666666L, "gray40"},
    {0x666666L, "grey40"},
    {0x696969L, "gray41"},
    {0x696969L, "grey41"},
    {0x6b6b6bL, "gray42"},
    {0x6b6b6bL, "grey42"},
    {0x6e6e6eL, "gray43"},
    {0x6e6e6eL, "grey43"},
    {0x707070L, "gray44"},
    {0x707070L, "grey44"},
    {0x737373L, "gray45"},
    {0x737373L, "grey45"},
    {0x757575L, "gray46"},
    {0x757575L, "grey46"},
    {0x787878L, "gray47"},
    {0x787878L, "grey47"},
    {0x7a7a7aL, "gray48"},
    {0x7a7a7aL, "grey48"},
    {0x7d7d7dL, "gray49"},
    {0x7d7d7dL, "grey49"},
    {0x7f7f7fL, "gray50"},
    {0x7f7f7fL, "grey50"},
    {0x828282L, "gray51"},
    {0x828282L, "grey51"},
    {0x858585L, "gray52"},
    {0x858585L, "grey52"},
    {0x878787L, "gray53"},
    {0x878787L, "grey53"},
    {0x8a8a8aL, "gray54"},
    {0x8a8a8aL, "grey54"},
    {0x8c8c8cL, "gray55"},
    {0x8c8c8cL, "grey55"},
    {0x8f8f8fL, "gray56"},
    {0x8f8f8fL, "grey56"},
    {0x919191L, "gray57"},
    {0x919191L, "grey57"},
    {0x949494L, "gray58"},
    {0x949494L, "grey58"},
    {0x969696L, "gray59"},
    {0x969696L, "grey59"},
    {0x999999L, "gray60"},
    {0x999999L, "grey60"},
    {0x9c9c9cL, "gray61"},
    {0x9c9c9cL, "grey61"},
    {0x9e9e9eL, "gray62"},
    {0x9e9e9eL, "grey62"},
    {0xa1a1a1L, "gray63"},
    {0xa1a1a1L, "grey63"},
    {0xa3a3a3L, "gray64"},
    {0xa3a3a3L, "grey64"},
    {0xa6a6a6L, "gray65"},
    {0xa6a6a6L, "grey65"},
    {0xa8a8a8L, "gray66"},
    {0xa8a8a8L, "grey66"},
    {0xabababL, "gray67"},
    {0xabababL, "grey67"},
    {0xadadadL, "gray68"},
    {0xadadadL, "grey68"},
    {0xb0b0b0L, "gray69"},
    {0xb0b0b0L, "grey69"},
    {0xb3b3b3L, "gray70"},
    {0xb3b3b3L, "grey70"},
    {0xb5b5b5L, "gray71"},
    {0xb5b5b5L, "grey71"},
    {0xb8b8b8L, "gray72"},
    {0xb8b8b8L, "grey72"},
    {0xbababaL, "gray73"},
    {0xbababaL, "grey73"},
    {0xbdbdbdL, "gray74"},
    {0xbdbdbdL, "grey74"},
    {0xbfbfbfL, "gray75"},
    {0xbfbfbfL, "grey75"},
    {0xc2c2c2L, "gray76"},
    {0xc2c2c2L, "grey76"},
    {0xc4c4c4L, "gray77"},
    {0xc4c4c4L, "grey77"},
    {0xc7c7c7L, "gray78"},
    {0xc7c7c7L, "grey78"},
    {0xc9c9c9L, "gray79"},
    {0xc9c9c9L, "grey79"},
    {0xccccccL, "gray80"},
    {0xccccccL, "grey80"},
    {0xcfcfcfL, "gray81"},
    {0xcfcfcfL, "grey81"},
    {0xd1d1d1L, "gray82"},
    {0xd1d1d1L, "grey82"},
    {0xd4d4d4L, "gray83"},
    {0xd4d4d4L, "grey83"},
    {0xd6d6d6L, "gray84"},
    {0xd6d6d6L, "grey84"},
    {0xd9d9d9L, "gray85"},
    {0xd9d9d9L, "grey85"},
    {0xdbdbdbL, "gray86"},
    {0xdbdbdbL, "grey86"},
    {0xdededeL, "gray87"},
    {0xdededeL, "grey87"},
    {0xe0e0e0L, "gray88"},
    {0xe0e0e0L, "grey88"},
    {0xe3e3e3L, "gray89"},
    {0xe3e3e3L, "grey89"},
    {0xe5e5e5L, "gray90"},
    {0xe5e5e5L, "grey90"},
    {0xe8e8e8L, "gray91"},
    {0xe8e8e8L, "grey91"},
    {0xebebebL, "gray92"},
    {0xebebebL, "grey92"},
    {0xedededL, "gray93"},
    {0xedededL, "grey93"},
    {0xf0f0f0L, "gray94"},
    {0xf0f0f0L, "grey94"},
    {0xf2f2f2L, "gray95"},
    {0xf2f2f2L, "grey95"},
    {0xf5f5f5L, "gray96"},
    {0xf5f5f5L, "grey96"},
    {0xf7f7f7L, "gray97"},
    {0xf7f7f7L, "grey97"},
    {0xfafafaL, "gray98"},
    {0xfafafaL, "grey98"},
    {0xfcfcfcL, "gray99"},
    {0xfcfcfcL, "grey99"},
    {0xffffffL, "gray100"},
    {0xffffffL, "grey100"},
    {0x000000L, NULL}
};
